/* XMLBackground.c generated by valac 0.46.13, the Vala compiler
 * generated from XMLBackground.vala, do not modify */

/*
* Copyright (C) 2020 - Fondo
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU Affero General Public License as published
* by the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Affero General Public License for more details.
*
* You should have received a copy of the GNU Affero General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*
*/

#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>

#define APP_UTILS_TYPE_XML_BACKGROUND (app_utils_xml_background_get_type ())
#define APP_UTILS_XML_BACKGROUND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_UTILS_TYPE_XML_BACKGROUND, AppUtilsXMLBackground))
#define APP_UTILS_XML_BACKGROUND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_UTILS_TYPE_XML_BACKGROUND, AppUtilsXMLBackgroundClass))
#define APP_UTILS_IS_XML_BACKGROUND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_UTILS_TYPE_XML_BACKGROUND))
#define APP_UTILS_IS_XML_BACKGROUND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_UTILS_TYPE_XML_BACKGROUND))
#define APP_UTILS_XML_BACKGROUND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_UTILS_TYPE_XML_BACKGROUND, AppUtilsXMLBackgroundClass))

typedef struct _AppUtilsXMLBackground AppUtilsXMLBackground;
typedef struct _AppUtilsXMLBackgroundClass AppUtilsXMLBackgroundClass;
typedef struct _AppUtilsXMLBackgroundPrivate AppUtilsXMLBackgroundPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _AppUtilsParamSpecXMLBackground AppUtilsParamSpecXMLBackground;

struct _AppUtilsXMLBackground {
	GTypeInstance parent_instance;
	volatile int ref_count;
	AppUtilsXMLBackgroundPrivate * priv;
};

struct _AppUtilsXMLBackgroundClass {
	GTypeClass parent_class;
	void (*finalize) (AppUtilsXMLBackground *self);
};

struct _AppUtilsXMLBackgroundPrivate {
	GFile* collection_file;
	GList* background_list;
	gint static_time;
	gint transition_time;
	GDateTime* start_time;
};

struct _AppUtilsParamSpecXMLBackground {
	GParamSpec parent_instance;
};

static gint AppUtilsXMLBackground_private_offset;
static gpointer app_utils_xml_background_parent_class = NULL;

gpointer app_utils_xml_background_ref (gpointer instance);
void app_utils_xml_background_unref (gpointer instance);
GParamSpec* app_utils_param_spec_xml_background (const gchar* name,
                                                 const gchar* nick,
                                                 const gchar* blurb,
                                                 GType object_type,
                                                 GParamFlags flags);
void app_utils_value_set_xml_background (GValue* value,
                                         gpointer v_object);
void app_utils_value_take_xml_background (GValue* value,
                                          gpointer v_object);
gpointer app_utils_value_get_xml_background (const GValue* value);
GType app_utils_xml_background_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppUtilsXMLBackground, app_utils_xml_background_unref)
AppUtilsXMLBackground* app_utils_xml_background_new (const gchar* collection_file,
                                                     GList* wallpapers_path_list,
                                                     gint static_time,
                                                     gint transition_time,
                                                     GDateTime* start_time);
AppUtilsXMLBackground* app_utils_xml_background_construct (GType object_type,
                                                           const gchar* collection_file,
                                                           GList* wallpapers_path_list,
                                                           gint static_time,
                                                           gint transition_time,
                                                           GDateTime* start_time);
static gchar* app_utils_xml_background_generate_xml (AppUtilsXMLBackground* self);
static gchar* app_utils_xml_background_generate_starttime (AppUtilsXMLBackground* self);
static gchar* app_utils_xml_background_generate_static (AppUtilsXMLBackground* self,
                                                 const gchar* background,
                                                 gint duration);
static gchar* app_utils_xml_background_generate_transition (AppUtilsXMLBackground* self,
                                                     const gchar* background_from,
                                                     const gchar* background_to,
                                                     gint duration);
static gint app_utils_xml_background_get_transition_time (AppUtilsXMLBackground* self);
GFile* app_utils_xml_background_write_background (AppUtilsXMLBackground* self);
static guint8* _vala_array_dup1 (guint8* self,
                          int length);
static gchar* app_utils_xml_background_scape_string (AppUtilsXMLBackground* self,
                                              const gchar* unsafe_string);
static void app_utils_xml_background_finalize (AppUtilsXMLBackground * obj);

static inline gpointer
app_utils_xml_background_get_instance_private (AppUtilsXMLBackground* self)
{
	return G_STRUCT_MEMBER_P (self, AppUtilsXMLBackground_private_offset);
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
	return self ? g_date_time_ref (self) : NULL;
}

AppUtilsXMLBackground*
app_utils_xml_background_construct (GType object_type,
                                    const gchar* collection_file,
                                    GList* wallpapers_path_list,
                                    gint static_time,
                                    gint transition_time,
                                    GDateTime* start_time)
{
	AppUtilsXMLBackground* self = NULL;
	GFile* _tmp0_;
	GDateTime* _tmp1_;
	g_return_val_if_fail (collection_file != NULL, NULL);
	g_return_val_if_fail (start_time != NULL, NULL);
	self = (AppUtilsXMLBackground*) g_type_create_instance (object_type);
	self->priv->background_list = wallpapers_path_list;
	_tmp0_ = g_file_new_for_path (collection_file);
	_g_object_unref0 (self->priv->collection_file);
	self->priv->collection_file = _tmp0_;
	self->priv->static_time = static_time;
	self->priv->transition_time = transition_time;
	_tmp1_ = _g_date_time_ref0 (start_time);
	_g_date_time_unref0 (self->priv->start_time);
	self->priv->start_time = _tmp1_;
	return self;
}

AppUtilsXMLBackground*
app_utils_xml_background_new (const gchar* collection_file,
                              GList* wallpapers_path_list,
                              gint static_time,
                              gint transition_time,
                              GDateTime* start_time)
{
	return app_utils_xml_background_construct (APP_UTILS_TYPE_XML_BACKGROUND, collection_file, wallpapers_path_list, static_time, transition_time, start_time);
}

static gchar*
app_utils_xml_background_generate_xml (AppUtilsXMLBackground* self)
{
	gint num_backgrounds = 0;
	GList* _tmp0_;
	gchar* full_string = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->background_list;
	num_backgrounds = (gint) g_list_length (_tmp0_);
	_tmp1_ = app_utils_xml_background_generate_starttime (self);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strconcat ("<background>\n", _tmp2_, NULL);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	full_string = _tmp4_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				gchar* current = NULL;
				GList* _tmp7_;
				gconstpointer _tmp8_;
				gchar* _tmp9_;
				const gchar* _tmp10_;
				const gchar* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
				gint _tmp15_ = 0;
				gint next_transition = 0;
				gchar* next = NULL;
				GList* _tmp16_;
				gconstpointer _tmp17_;
				gchar* _tmp18_;
				const gchar* _tmp19_;
				const gchar* _tmp20_;
				const gchar* _tmp21_;
				gchar* _tmp22_;
				gchar* _tmp23_;
				gchar* _tmp24_;
				if (!_tmp5_) {
					gint _tmp6_;
					_tmp6_ = i;
					i = _tmp6_ + 1;
				}
				_tmp5_ = FALSE;
				if (!(i < num_backgrounds)) {
					break;
				}
				_tmp7_ = self->priv->background_list;
				_tmp8_ = g_list_nth_data (_tmp7_, (guint) i);
				_tmp9_ = g_strdup ((const gchar*) _tmp8_);
				current = _tmp9_;
				_tmp10_ = full_string;
				_tmp11_ = current;
				_tmp12_ = app_utils_xml_background_generate_static (self, _tmp11_, self->priv->static_time);
				_tmp13_ = _tmp12_;
				_tmp14_ = g_strconcat (_tmp10_, _tmp13_, NULL);
				_g_free0 (full_string);
				full_string = _tmp14_;
				_g_free0 (_tmp13_);
				if ((i + 1) >= num_backgrounds) {
					_tmp15_ = 0;
				} else {
					_tmp15_ = i + 1;
				}
				next_transition = _tmp15_;
				_tmp16_ = self->priv->background_list;
				_tmp17_ = g_list_nth_data (_tmp16_, (guint) next_transition);
				_tmp18_ = g_strdup ((const gchar*) _tmp17_);
				next = _tmp18_;
				_tmp19_ = full_string;
				_tmp20_ = current;
				_tmp21_ = next;
				_tmp22_ = app_utils_xml_background_generate_transition (self, _tmp20_, _tmp21_, app_utils_xml_background_get_transition_time (self));
				_tmp23_ = _tmp22_;
				_tmp24_ = g_strconcat (_tmp19_, _tmp23_, NULL);
				_g_free0 (full_string);
				full_string = _tmp24_;
				_g_free0 (_tmp23_);
				_g_free0 (next);
				_g_free0 (current);
			}
		}
	}
	_tmp25_ = full_string;
	_tmp26_ = g_strconcat (_tmp25_, "</background>", NULL);
	_g_free0 (full_string);
	full_string = _tmp26_;
	result = full_string;
	return result;
}

static gint
app_utils_xml_background_get_transition_time (AppUtilsXMLBackground* self)
{
	gchar* desktop_name = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = g_getenv ("XDG_CURRENT_DESKTOP");
	_tmp1_ = g_strdup (_tmp0_);
	desktop_name = _tmp1_;
	_tmp2_ = desktop_name;
	if (g_strcmp0 (_tmp2_, "Pantheon") == 0) {
		result = 0;
		_g_free0 (desktop_name);
		return result;
	}
	result = self->priv->transition_time;
	_g_free0 (desktop_name);
	return result;
}

/**
         *  Writes an XML background file and returns the file
        */
static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	g_return_val_if_fail (self != NULL, NULL);
	res = (guint8*) self;
	res_length1 = -1;
	_res_size_ = res_length1;
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	res_length1 = (gint) _tmp1_;
	_tmp2_ = res;
	_tmp2__length1 = res_length1;
	if (result_length1) {
		*result_length1 = _tmp2__length1;
	}
	result = _tmp2_;
	return result;
}

static guint8*
_vala_array_dup1 (guint8* self,
                  int length)
{
	if (length > 0) {
		return g_memdup (self, length * sizeof (guint8));
	}
	return NULL;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

GFile*
app_utils_xml_background_write_background (AppUtilsXMLBackground* self)
{
	GFile* _tmp22_;
	GFile* _tmp23_;
	GError* _inner_error0_ = NULL;
	GFile* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	{
		gchar* xml_text = NULL;
		gchar* _tmp0_;
		GFile* _tmp1_;
		GFileOutputStream* _tmp3_ = NULL;
		GFile* _tmp4_;
		GFileOutputStream* _tmp5_;
		GDataOutputStream* dos = NULL;
		GDataOutputStream* _tmp6_;
		guint8* data = NULL;
		const gchar* _tmp7_;
		guint8* _tmp8_;
		gint _tmp8__length1;
		guint8* _tmp9_;
		gint _tmp9__length1;
		guint8* _tmp10_;
		gint _tmp10__length1;
		gint data_length1;
		gint _data_size_;
		glong written = 0L;
		GFile* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		_tmp0_ = app_utils_xml_background_generate_xml (self);
		xml_text = _tmp0_;
		_tmp1_ = self->priv->collection_file;
		if (g_file_query_exists (_tmp1_, NULL)) {
			GFile* _tmp2_;
			_tmp2_ = self->priv->collection_file;
			g_file_delete (_tmp2_, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_free0 (xml_text);
				goto __catch18_g_error;
			}
		}
		_tmp4_ = self->priv->collection_file;
		_tmp5_ = g_file_create (_tmp4_, G_FILE_CREATE_REPLACE_DESTINATION, NULL, &_inner_error0_);
		_tmp3_ = _tmp5_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (xml_text);
			goto __catch18_g_error;
		}
		_tmp6_ = g_data_output_stream_new ((GOutputStream*) _tmp3_);
		dos = _tmp6_;
		_tmp7_ = xml_text;
		_tmp8_ = string_get_data (_tmp7_, &_tmp8__length1);
		_tmp9_ = _tmp8_;
		_tmp9__length1 = _tmp8__length1;
		_tmp10_ = (_tmp9_ != NULL) ? _vala_array_dup1 (_tmp9_, _tmp9__length1) : ((gpointer) _tmp9_);
		_tmp10__length1 = _tmp9__length1;
		data = _tmp10_;
		data_length1 = _tmp10__length1;
		_data_size_ = data_length1;
		written = (glong) 0;
		while (TRUE) {
			guint8* _tmp11_;
			gint _tmp11__length1;
			gssize _tmp12_ = 0L;
			GDataOutputStream* _tmp13_;
			guint8* _tmp14_;
			gint _tmp14__length1;
			guint8* _tmp15_;
			gint _tmp15__length1;
			_tmp11_ = data;
			_tmp11__length1 = data_length1;
			if (!(written < ((glong) _tmp11__length1))) {
				break;
			}
			_tmp13_ = dos;
			_tmp14_ = data;
			_tmp14__length1 = data_length1;
			_tmp15_ = data;
			_tmp15__length1 = data_length1;
			_tmp12_ = g_output_stream_write ((GOutputStream*) _tmp13_, _tmp14_ + ((gint) written), (gsize) (_tmp15__length1 - ((gint) written)), NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				data = (g_free (data), NULL);
				_g_object_unref0 (dos);
				_g_object_unref0 (_tmp3_);
				_g_free0 (xml_text);
				goto __catch18_g_error;
			}
			written += (glong) _tmp12_;
		}
		_tmp16_ = self->priv->collection_file;
		_tmp17_ = g_file_get_path (_tmp16_);
		_tmp18_ = _tmp17_;
		g_message ("XMLBackground.vala:91: File %s written successfully.\n", _tmp18_);
		_g_free0 (_tmp18_);
		data = (g_free (data), NULL);
		_g_object_unref0 (dos);
		_g_object_unref0 (_tmp3_);
		_g_free0 (xml_text);
	}
	goto __finally18;
	__catch18_g_error:
	{
		GError* e = NULL;
		FILE* _tmp19_;
		GError* _tmp20_;
		const gchar* _tmp21_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp19_ = stderr;
		_tmp20_ = e;
		_tmp21_ = _tmp20_->message;
		fprintf (_tmp19_, "%s\n", _tmp21_);
		_g_error_free0 (e);
	}
	__finally18:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	_tmp22_ = self->priv->collection_file;
	_tmp23_ = _g_object_ref0 (_tmp22_);
	result = _tmp23_;
	return result;
}

static gchar*
app_utils_xml_background_generate_starttime (AppUtilsXMLBackground* self)
{
	gchar* year = NULL;
	GDateTime* _tmp0_;
	gchar* _tmp1_;
	gchar* month = NULL;
	GDateTime* _tmp2_;
	gchar* _tmp3_;
	gchar* day = NULL;
	GDateTime* _tmp4_;
	gchar* _tmp5_;
	gchar* hour = NULL;
	GDateTime* _tmp6_;
	gchar* _tmp7_;
	gchar* minute = NULL;
	GDateTime* _tmp8_;
	gchar* _tmp9_;
	gchar* second = NULL;
	GDateTime* _tmp10_;
	gchar* _tmp11_;
	gchar* starttime = NULL;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->start_time;
	_tmp1_ = g_strdup_printf ("%d", g_date_time_get_year (_tmp0_));
	year = _tmp1_;
	_tmp2_ = self->priv->start_time;
	_tmp3_ = g_strdup_printf ("%d", g_date_time_get_month (_tmp2_));
	month = _tmp3_;
	_tmp4_ = self->priv->start_time;
	_tmp5_ = g_strdup_printf ("%d", g_date_time_get_day_of_month (_tmp4_));
	day = _tmp5_;
	_tmp6_ = self->priv->start_time;
	_tmp7_ = g_strdup_printf ("%d", g_date_time_get_hour (_tmp6_));
	hour = _tmp7_;
	_tmp8_ = self->priv->start_time;
	_tmp9_ = g_strdup_printf ("%d", g_date_time_get_minute (_tmp8_));
	minute = _tmp9_;
	_tmp10_ = self->priv->start_time;
	_tmp11_ = g_strdup_printf ("%d", g_date_time_get_second (_tmp10_));
	second = _tmp11_;
	_tmp12_ = g_strconcat ("<starttime>\n" "\t<year>", year, NULL);
	_tmp13_ = _tmp12_;
	_tmp14_ = g_strconcat (_tmp13_, "</year>\n", NULL);
	_tmp15_ = _tmp14_;
	_tmp16_ = g_strconcat (_tmp15_, "\t<month>", NULL);
	_tmp17_ = _tmp16_;
	_tmp18_ = g_strconcat (_tmp17_, month, NULL);
	_tmp19_ = _tmp18_;
	_tmp20_ = g_strconcat (_tmp19_, "</month>\n", NULL);
	_tmp21_ = _tmp20_;
	_tmp22_ = g_strconcat (_tmp21_, "\t<day>", NULL);
	_tmp23_ = _tmp22_;
	_tmp24_ = g_strconcat (_tmp23_, day, NULL);
	_tmp25_ = _tmp24_;
	_tmp26_ = g_strconcat (_tmp25_, "</day>\n", NULL);
	_tmp27_ = _tmp26_;
	_tmp28_ = g_strconcat (_tmp27_, "\t<hour>", NULL);
	_tmp29_ = _tmp28_;
	_tmp30_ = g_strconcat (_tmp29_, hour, NULL);
	_tmp31_ = _tmp30_;
	_tmp32_ = g_strconcat (_tmp31_, "</hour>\n", NULL);
	_tmp33_ = _tmp32_;
	_tmp34_ = g_strconcat (_tmp33_, "\t<minute>", NULL);
	_tmp35_ = _tmp34_;
	_tmp36_ = g_strconcat (_tmp35_, minute, NULL);
	_tmp37_ = _tmp36_;
	_tmp38_ = g_strconcat (_tmp37_, "</minute>\n", NULL);
	_tmp39_ = _tmp38_;
	_tmp40_ = g_strconcat (_tmp39_, "\t<second>", NULL);
	_tmp41_ = _tmp40_;
	_tmp42_ = g_strconcat (_tmp41_, second, NULL);
	_tmp43_ = _tmp42_;
	_tmp44_ = g_strconcat (_tmp43_, "</second>\n", NULL);
	_tmp45_ = _tmp44_;
	_tmp46_ = g_strconcat (_tmp45_, "</starttime>\n", NULL);
	_tmp47_ = _tmp46_;
	_g_free0 (_tmp45_);
	_g_free0 (_tmp43_);
	_g_free0 (_tmp41_);
	_g_free0 (_tmp39_);
	_g_free0 (_tmp37_);
	_g_free0 (_tmp35_);
	_g_free0 (_tmp33_);
	_g_free0 (_tmp31_);
	_g_free0 (_tmp29_);
	_g_free0 (_tmp27_);
	_g_free0 (_tmp25_);
	_g_free0 (_tmp23_);
	_g_free0 (_tmp21_);
	_g_free0 (_tmp19_);
	_g_free0 (_tmp17_);
	_g_free0 (_tmp15_);
	_g_free0 (_tmp13_);
	starttime = _tmp47_;
	result = starttime;
	_g_free0 (second);
	_g_free0 (minute);
	_g_free0 (hour);
	_g_free0 (day);
	_g_free0 (month);
	_g_free0 (year);
	return result;
}

static gchar*
app_utils_xml_background_generate_static (AppUtilsXMLBackground* self,
                                          const gchar* background,
                                          gint duration)
{
	gchar* duration_str = NULL;
	gchar* _tmp0_;
	gchar* safe_background = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (background != NULL, NULL);
	_tmp0_ = g_strdup_printf ("%g.0", (gdouble) duration);
	duration_str = _tmp0_;
	_tmp1_ = app_utils_xml_background_scape_string (self, background);
	safe_background = _tmp1_;
	_tmp2_ = g_strconcat ("<static>\n" "\t<duration>", duration_str, NULL);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strconcat (_tmp3_, "</duration>\n", NULL);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_strconcat (_tmp5_, "\t<file>", NULL);
	_tmp7_ = _tmp6_;
	_tmp8_ = g_strconcat (_tmp7_, safe_background, NULL);
	_tmp9_ = _tmp8_;
	_tmp10_ = g_strconcat (_tmp9_, "</file>\n", NULL);
	_tmp11_ = _tmp10_;
	_tmp12_ = g_strconcat (_tmp11_, "</static>\n", NULL);
	_tmp13_ = _tmp12_;
	_g_free0 (_tmp11_);
	_g_free0 (_tmp9_);
	_g_free0 (_tmp7_);
	_g_free0 (_tmp5_);
	_g_free0 (_tmp3_);
	result = _tmp13_;
	_g_free0 (safe_background);
	_g_free0 (duration_str);
	return result;
}

static gchar*
app_utils_xml_background_generate_transition (AppUtilsXMLBackground* self,
                                              const gchar* background_from,
                                              const gchar* background_to,
                                              gint duration)
{
	gchar* duration_str = NULL;
	gchar* _tmp0_;
	gchar* safe_bkg_from = NULL;
	gchar* _tmp1_;
	gchar* safe_bkg_to = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (background_from != NULL, NULL);
	g_return_val_if_fail (background_to != NULL, NULL);
	_tmp0_ = g_strdup_printf ("%g.0", (gdouble) duration);
	duration_str = _tmp0_;
	_tmp1_ = app_utils_xml_background_scape_string (self, background_from);
	safe_bkg_from = _tmp1_;
	_tmp2_ = app_utils_xml_background_scape_string (self, background_to);
	safe_bkg_to = _tmp2_;
	_tmp3_ = g_strconcat ("<transition>\n" "\t<duration>", duration_str, NULL);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strconcat (_tmp4_, "</duration>\n", NULL);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_strconcat (_tmp6_, "\t<from>", NULL);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_strconcat (_tmp8_, safe_bkg_from, NULL);
	_tmp10_ = _tmp9_;
	_tmp11_ = g_strconcat (_tmp10_, "</from>\n", NULL);
	_tmp12_ = _tmp11_;
	_tmp13_ = g_strconcat (_tmp12_, "\t<to>", NULL);
	_tmp14_ = _tmp13_;
	_tmp15_ = g_strconcat (_tmp14_, safe_bkg_to, NULL);
	_tmp16_ = _tmp15_;
	_tmp17_ = g_strconcat (_tmp16_, "</to>\n", NULL);
	_tmp18_ = _tmp17_;
	_tmp19_ = g_strconcat (_tmp18_, "</transition>\n", NULL);
	_tmp20_ = _tmp19_;
	_g_free0 (_tmp18_);
	_g_free0 (_tmp16_);
	_g_free0 (_tmp14_);
	_g_free0 (_tmp12_);
	_g_free0 (_tmp10_);
	_g_free0 (_tmp8_);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp4_);
	result = _tmp20_;
	_g_free0 (safe_bkg_to);
	_g_free0 (safe_bkg_from);
	_g_free0 (duration_str);
	return result;
}

static gchar*
app_utils_xml_background_scape_string (AppUtilsXMLBackground* self,
                                       const gchar* unsafe_string)
{
	gchar* _tmp0_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (unsafe_string != NULL, NULL);
	_tmp0_ = g_markup_escape_text (unsafe_string, (gssize) -1);
	result = _tmp0_;
	return result;
}

static void
app_utils_value_xml_background_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
app_utils_value_xml_background_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		app_utils_xml_background_unref (value->data[0].v_pointer);
	}
}

static void
app_utils_value_xml_background_copy_value (const GValue* src_value,
                                           GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = app_utils_xml_background_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
app_utils_value_xml_background_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
app_utils_value_xml_background_collect_value (GValue* value,
                                              guint n_collect_values,
                                              GTypeCValue* collect_values,
                                              guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		AppUtilsXMLBackground * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = app_utils_xml_background_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
app_utils_value_xml_background_lcopy_value (const GValue* value,
                                            guint n_collect_values,
                                            GTypeCValue* collect_values,
                                            guint collect_flags)
{
	AppUtilsXMLBackground ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = app_utils_xml_background_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
app_utils_param_spec_xml_background (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags)
{
	AppUtilsParamSpecXMLBackground* spec;
	g_return_val_if_fail (g_type_is_a (object_type, APP_UTILS_TYPE_XML_BACKGROUND), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
app_utils_value_get_xml_background (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, APP_UTILS_TYPE_XML_BACKGROUND), NULL);
	return value->data[0].v_pointer;
}

void
app_utils_value_set_xml_background (GValue* value,
                                    gpointer v_object)
{
	AppUtilsXMLBackground * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, APP_UTILS_TYPE_XML_BACKGROUND));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, APP_UTILS_TYPE_XML_BACKGROUND));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		app_utils_xml_background_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		app_utils_xml_background_unref (old);
	}
}

void
app_utils_value_take_xml_background (GValue* value,
                                     gpointer v_object)
{
	AppUtilsXMLBackground * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, APP_UTILS_TYPE_XML_BACKGROUND));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, APP_UTILS_TYPE_XML_BACKGROUND));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		app_utils_xml_background_unref (old);
	}
}

static void
app_utils_xml_background_class_init (AppUtilsXMLBackgroundClass * klass,
                                     gpointer klass_data)
{
	app_utils_xml_background_parent_class = g_type_class_peek_parent (klass);
	((AppUtilsXMLBackgroundClass *) klass)->finalize = app_utils_xml_background_finalize;
	g_type_class_adjust_private_offset (klass, &AppUtilsXMLBackground_private_offset);
}

static void
app_utils_xml_background_instance_init (AppUtilsXMLBackground * self,
                                        gpointer klass)
{
	self->priv = app_utils_xml_background_get_instance_private (self);
	self->ref_count = 1;
}

static void
app_utils_xml_background_finalize (AppUtilsXMLBackground * obj)
{
	AppUtilsXMLBackground * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, APP_UTILS_TYPE_XML_BACKGROUND, AppUtilsXMLBackground);
	g_signal_handlers_destroy (self);
	_g_object_unref0 (self->priv->collection_file);
	_g_date_time_unref0 (self->priv->start_time);
}

/**
     * The {@code XMLBackground} class. Generates and saves to disk an XML file
     * with the requested format for a wallpaper slideshow
     */
GType
app_utils_xml_background_get_type (void)
{
	static volatile gsize app_utils_xml_background_type_id__volatile = 0;
	if (g_once_init_enter (&app_utils_xml_background_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { app_utils_value_xml_background_init, app_utils_value_xml_background_free_value, app_utils_value_xml_background_copy_value, app_utils_value_xml_background_peek_pointer, "p", app_utils_value_xml_background_collect_value, "p", app_utils_value_xml_background_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (AppUtilsXMLBackgroundClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) app_utils_xml_background_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AppUtilsXMLBackground), 0, (GInstanceInitFunc) app_utils_xml_background_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType app_utils_xml_background_type_id;
		app_utils_xml_background_type_id = g_type_register_fundamental (g_type_fundamental_next (), "AppUtilsXMLBackground", &g_define_type_info, &g_define_type_fundamental_info, 0);
		AppUtilsXMLBackground_private_offset = g_type_add_instance_private (app_utils_xml_background_type_id, sizeof (AppUtilsXMLBackgroundPrivate));
		g_once_init_leave (&app_utils_xml_background_type_id__volatile, app_utils_xml_background_type_id);
	}
	return app_utils_xml_background_type_id__volatile;
}

gpointer
app_utils_xml_background_ref (gpointer instance)
{
	AppUtilsXMLBackground * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
app_utils_xml_background_unref (gpointer instance)
{
	AppUtilsXMLBackground * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		APP_UTILS_XML_BACKGROUND_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

